apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ .Values.instanceName }}
  labels:
    app: {{ .Values.instanceName }}
spec:
  replicas: 1
  selector:
    matchLabels:
      app: {{ .Values.instanceName }}
  template:
    metadata:
      labels:
        app: {{ .Values.instanceName }}
    spec:
      # affinity:
      #   podAffinity:
      #     requiredDuringSchedulingIgnoredDuringExecution:
      #       - labelSelector:
      #           matchLabels:
      #             app: {{ .Values.instanceName }}
      #         topologyKey: kubernetes.io/hostname

      containers:
        - image: {{ .Values.image }}
          {{- if .Values.alwaysPullImage }}
          imagePullPolicy: Always
          {{- end}}
          name: agepdev
          volumeMounts:
            - mountPath: /home/agepinfo/dev-storage/
              name: dev-storage-v
          env:
            - name: PASSWORD
              valueFrom:
                secretKeyRef:
                  key: vscodePassword
                  name: {{ .Values.secretName }}
            - name: DEFAULT_WORKSPACE
              value: /home/agepinfo/dev-storage/code/
            
            {{- if .Values.env }}
            {{- range .Values.env }}
            - name: {{ .name }}
              value: {{ .value }}
            {{- end }}
            {{- end }}
            
            {{- if .Values.secretEnv }}
            {{- range .Values.secretEnv }}
            - name: {{ .name }}
              valueFrom:
                secretKeyRef:
                  key: {{ .key }}
                  name: {{ $.Values.secretName }}
            {{- end }}
            {{- end }}
          ports:
            - containerPort: 8443
              protocol: TCP
          resources: {}

      volumes:
        - name: dev-storage-v
          persistentVolumeClaim:
            claimName: {{ .Values.instanceName }}-dev-storage-pvc
